<?php
add_action( 'init','tmpl_classified_get_posts' );

/* Filters for classifieds search */
function tmpl_classified_get_posts() {
	if ( ! is_admin() ) {
		if ( isset( $_REQUEST['search_template'] ) && $_REQUEST['search_template'] == 1 && isset( $_REQUEST['post_type'] ) && $_REQUEST['post_type'] == CUSTOM_POST_TYPE_CLASSIFIED ) {
			add_action( 'pre_get_posts','tmpl_classified_manager_pre_get_posts',12 );
			add_action( 'pre_get_posts', 'advance_search_template_function',11 );
		} else {
			add_action( 'pre_get_posts','tmpl_classified_manager_pre_get_posts' );
		}
	}
}
function tmpl_classified_manager_pre_get_posts( $query ) {
	global $wp_query,$wpdb;

	if ( ! is_author() && ! is_search() && is_tax() ) {
		$current_term = $wp_query->get_queried_object();
	}
	if ( ( ! is_search() && ! is_author())&& isset( $query->query_vars['post_type'] ) && $query->query_vars['post_type'] != 'listing' && is_archive() || (is_archive() && (isset( $current_term->taxonomy ) && ($current_term->taxonomy != 'listing' || $current_term->taxonomy != 'listing'))) ) {
		if ( isset( $current_term ) && ($current_term->taxonomy != 'listing' || $current_term->taxonomy == CUSTOM_TAG_TYPE_CLASSIFIED) ||  (is_archive() && ! get_query_var( 'cat' ) && $query->query_vars['post_type'] != 'listing') ) {
			$query->set( 'post_status', array( 'publish', 'inherit' ) );

			add_filter( 'posts_orderby', 'tmpl_classified_manager_filter_orderby',99 );
			/* Alphabets wise ordering */
			if ( isset( $_REQUEST['sortby'] ) && $_REQUEST['sortby'] != '' ) {
				add_filter( 'posts_where', 'tmpl_classified_alphabets_sortby_where' );
			}
		}
	}

	if ( is_search() && (isset( $_REQUEST['t'] ) && $_REQUEST['t'] != 'listing') || (isset( $_REQUEST['post_type'] ) && $_REQUEST['post_type'] != 'listing' && ! isset( $_REQUEST['preview'] ) && $_REQUEST['preview'] != 'true' ) || (isset( $_REQUEST['search_template'] ) && $_REQUEST['search_template'] == 1 || (isset( $_REQUEST['post_type'] ) && $_REQUEST['post_type'] != 'listing' && ! isset( $_REQUEST['preview'] ) && $_REQUEST['preview'] != 'true')) ) {
		remove_filter( 'posts_orderby', 'feature_filter_order',99 );
		add_filter( 'posts_orderby', 'tmpl_classified_manager_filter_orderby' );
		/* Alphabets wise ordering */
		if ( isset( $_REQUEST['sortby'] ) && $_REQUEST['sortby'] != '' ) {
			add_filter( 'posts_where', 'tmpl_classified_alphabets_sortby_where' );
		}
		if ( isset( $_REQUEST['post_type'] ) && CUSTOM_POST_TYPE_CLASSIFIED == $_REQUEST['post_type'] ) {
			add_filter( 'posts_where', 'tmpl_classified_searching_filter_where' );
		}
		if ( is_plugin_active( 'sitepress-multilingual-cms/sitepress.php' ) ) {
			add_filter( 'posts_where', 'tmpl_classfied_wpml_milewise_search_language' );
		}
	} else {
		if ( is_plugin_active( 'sitepress-multilingual-cms/sitepress.php' ) ) {
			remove_filter( 'posts_where', 'tmpl_classfied_wpml_milewise_search_language' );
		}
	}

}


/*	display the category page listing by ordering wise.*/
function tmpl_classified_manager_filter_orderby( $orderby ) {
	global $wpdb,$wp_query;
	if ( (isset( $_REQUEST['csortby'] ) && ($_REQUEST['csortby'] == 'title_asc' || $_REQUEST['csortby'] == 'alphabetical')) || (isset( $_REQUEST['classified_sortby'] ) && ($_REQUEST['classified_sortby'] == 'alphabetical' || $_REQUEST['classified_sortby'] == 'title_asc')) ) {
		$orderby = "$wpdb->posts.post_title ASC,(select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id=$wpdb->posts.ID and $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC";
	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'title_desc') || (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'title_desc') ) {
		$orderby = "$wpdb->posts.post_title DESC,(select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id=$wpdb->posts.ID and $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC";
	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'date_asc' )|| (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'date_asc') ) {
		$orderby = "$wpdb->posts.post_date ASC,(select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id=$wpdb->posts.ID and $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC";
	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'date_desc') || (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'date_desc') ) {
		$orderby = "$wpdb->posts.post_date DESC,(select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id=$wpdb->posts.ID and $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC";
	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'price_low_high') || (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'price_low_high') ) {
		$orderby = " (SELECT distinct ($wpdb->postmeta.meta_value +0) from $wpdb->postmeta where $wpdb->posts.ID = $wpdb->postmeta.post_id AND $wpdb->postmeta.meta_key like \"price\") ASC";
	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'price_high_low') || (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'price_high_low') ) {
		$orderby = " (select distinct ($wpdb->postmeta.meta_value+0) from $wpdb->postmeta where $wpdb->postmeta.post_id = $wpdb->posts.ID and $wpdb->postmeta.meta_key like \"price\") DESC";
	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'random') || (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'random') ) {
		$orderby = " (select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id=$wpdb->posts.ID and $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC,rand()";
	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'reviews')  || (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'reviews') ) {
		$orderby = 'DESC';
		$orderby = " $wpdb->posts.comment_count $orderby,(select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id=$wpdb->posts.ID and $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC";

	} elseif ( (isset( $_REQUEST['csortby'] ) && $_REQUEST['csortby'] == 'rating') || (isset( $_REQUEST['classified_sortby'] ) && $_REQUEST['classified_sortby'] == 'rating') ) {
		$orderby = " (select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id = $wpdb->posts.ID and $wpdb->postmeta.meta_key like \"average_rating\") DESC,(select distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where $wpdb->postmeta.post_id=$wpdb->posts.ID and $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC";
	} else {
		if ( ! isset( $_REQUEST['tevolution_sortby'] ) && $_REQUEST['tevolution_sortby'] == '' ) {
			$orderby = " (SELECT distinct $wpdb->postmeta.meta_value from $wpdb->postmeta where ($wpdb->posts.ID = $wpdb->postmeta.post_id) AND $wpdb->postmeta.meta_key = 'featured_c' AND $wpdb->postmeta.meta_value = 'c') DESC, $wpdb->posts.post_date DESC";
		}
	}// End if().

	return $orderby;
}

/* Find near my listing from current city */
function tmpl_classified_listing_search_posts_where( $where ) {
	global $wpdb,$wp_query,$post,$current_cityinfo;

	$lat = $current_cityinfo['lat'];
	$long = $current_cityinfo['lng'];

	$miles_range = explode( '-',sanitize_text_field( $_REQUEST['miles_range'] ) );
	$to_miles = trim( $miles_range[0] );
	$miles = trim( $miles_range[1] );
	$tbl_postcodes = $wpdb->prefix . 'postcodes';

	$where .= " AND ($wpdb->posts.ID in (SELECT post_id FROM  $tbl_postcodes WHERE truncate((degrees(acos( sin(radians(`latitude`)) * sin( radians('" . $lat . "')) + cos(radians(`latitude`)) * cos( radians('" . $lat . "')) * cos( radians(`longitude` - '" . $long . "') ) ) ) * 69.09),1) <= " . $miles . " AND truncate((degrees(acos( sin(radians(`latitude`)) * sin( radians('" . $lat . "')) + cos(radians(`latitude`)) * cos( radians('" . $lat . "')) * cos( radians(`longitude` - '" . $long . "') ) ) ) * 69.09),1) >= " . $to_miles . " ORDER BY truncate((degrees(acos( sin(radians(`latitude`)) * sin( radians('" . $lat . "')) + cos(radians(`latitude`)) * cos( radians('" . $lat . "')) * cos( radians(`longitude` - '" . $long . "') ) ) ) * 69.09),1) ASC))";

	return $where;
}

/* search filter where */
function tmpl_classified_searching_filter_where( $where ) {
	global $wpdb;

	$scat = trim( sanitize_text_field( $_REQUEST['scat'] ) );
	$saddress = trim( sanitize_text_field( $_REQUEST['saddress'] ) );

	$where .= " AND $wpdb->posts.post_type in ('" . CUSTOM_POST_TYPE_CLASSIFIED . "') AND ($wpdb->posts.post_status = 'publish') ";

	if ( $scat > 0 ) {
		$where .= " AND  $wpdb->posts.ID in (select $wpdb->term_relationships.object_id from $wpdb->term_relationships join $wpdb->term_taxonomy on $wpdb->term_taxonomy.term_taxonomy_id=$wpdb->term_relationships.term_taxonomy_id and $wpdb->term_taxonomy.term_id=\"$scat\" ) ";
	}
	if ( $saddress ) {
		$where .= " AND $wpdb->posts.ID in (select pm.post_id from $wpdb->postmeta pm where pm.meta_key like 'address' and pm.meta_value like \"%$saddress%\") ";
	}

		$post_meta_info = $wpdb->get_results("SELECT $wpdb->posts.* FROM $wpdb->posts INNER JOIN $wpdb->postmeta ON ($wpdb->posts.ID = $wpdb->postmeta.post_id) 
		INNER JOIN $wpdb->postmeta AS mt1 ON ($wpdb->posts.ID = mt1.post_id) INNER JOIN $wpdb->postmeta AS mt2 ON ($wpdb->posts.ID = mt2.post_id) WHERE 1=1 AND 
		$wpdb->posts.post_type = 'custom_fields' AND (($wpdb->posts.post_status = 'publish')) AND ($wpdb->postmeta.meta_key = 'sort_order' AND (mt1.meta_key = 'is_search' AND CAST(mt1.meta_value AS CHAR) = '1') AND (mt2.meta_key = 'post_type' AND CAST(mt2.meta_value AS CHAR) LIKE '%" . CUSTOM_POST_TYPE_CLASSIFIED . "%') )	GROUP BY $wpdb->posts.ID ORDER BY $wpdb->postmeta.meta_value+0 ASC");
		$return_arr = array();
	if ( $post_meta_info ) {

		foreach ( $post_meta_info as $post_meta_info_obj ) {
			if ( $post_meta_info_obj->ctype ) {
				$options = explode( ',',$post_meta_info_obj->option_values );
			}
			$custom_fields = array(
					'name'		=> get_post_meta( $post_meta_info_obj->ID,'htmlvar_name',true ),
					'label' 	=> $post_meta_info_obj->post_title,
					'htmlvar_name' 	=> get_post_meta( $post_meta_info_obj->ID,'htmlvar_name',true ),
					'default' 	=> get_post_meta( $post_meta_info_obj->ID,'default_value',true ),
					'type' 		=> get_post_meta( $post_meta_info_obj->ID,'ctype',true ),
					'desc'      => $post_meta_info_obj->post_content,
					'option_values' => get_post_meta( $post_meta_info_obj->ID,'option_values',true ),
					'is_require'  => get_post_meta( $post_meta_info_obj->ID,'is_require',true ),
					'is_active'  => get_post_meta( $post_meta_info_obj->ID,'is_active',true ),
					'show_on_listing'  => get_post_meta( $post_meta_info_obj->ID,'show_on_listing',true ),
					'show_on_detail'  => get_post_meta( $post_meta_info_obj->ID,'show_on_detail',true ),
					'validation_type'  => get_post_meta( $post_meta_info_obj->ID,'validation_type',true ),
					'style_class'  => get_post_meta( $post_meta_info_obj->ID,'style_class',true ),
					'extra_parameter'  => get_post_meta( $post_meta_info_obj->ID,'extra_parameter',true ),
					);
			if ( $options ) {
				$custom_fields['options'] = $options;
			}
			 $return_arr[ get_post_meta( $post_meta_info_obj->ID,'htmlvar_name',true ) ] = $custom_fields;
		}
	}
	$custom_metaboxes = $return_arr;
	foreach ( $custom_metaboxes as $key => $val ) {
		$name = $key;

		$value = sanitize_text_field( $_REQUEST[ $name ] );
		if ( $key != 'post_city_id' &&  $key != 'category' &&  $key != '' ) {
			if ( ! strstr( $key,'_radio' ) ) {
				if ( is_array( $_REQUEST[ $key ] ) ) {
					foreach ( $_REQUEST[ $key ] as $val ) {
						if ( ! empty( $val ) ) {
							$where .= " AND ($wpdb->posts.ID in (select $wpdb->postmeta.post_id from $wpdb->postmeta where $wpdb->postmeta.meta_key='$key' and ($wpdb->postmeta.meta_value like \"%$val%\" ))) ";
						}
					}
				} else {
					if ( $value != '' ) {
						$where .= " AND ($wpdb->posts.ID in (select $wpdb->postmeta.post_id from $wpdb->postmeta where $wpdb->postmeta.meta_key='$key' and ($wpdb->postmeta.meta_value like \"%$value%\" ))) ";
					}
				}
			} else {
				$key_value = explode( '_radio',$key );
				$where .= " AND ($wpdb->posts.ID in (select $wpdb->postmeta.post_id from $wpdb->postmeta where $wpdb->postmeta.meta_key='$key_value[0]' and ($wpdb->postmeta.meta_value like \"$value\" ))) ";
			}
		}
	}
	return $where;
}
function tmpl_classfied_wpml_milewise_search_language( $where ) {
	$language = ICL_LANGUAGE_CODE;
	$where .= " and t.language_code='" . $language . "'";
	return $where;
}
/*
 search by alphabetical
*/
function tmpl_classified_alphabets_sortby_where( $where ) {
	global $wpdb,$wp_query;
	if ( isset( $_REQUEST['sortby'] ) && $_REQUEST['sortby'] != '' ) {
		$where .= "  AND $wpdb->posts.post_title like '" . sanitize_text_field( $_REQUEST['sortby'] ) . "%'";
	}
	return $where;
}

/*
 * find near my listing from current city
 */
function directory_classified_search_posts_where( $where ) {
	global $wpdb,$wp_query,$post,$current_cityinfo;

	if ( isset( $_REQUEST['range_address'] ) && $_REQUEST['range_address'] != '' ) {
		if ( is_ssl() ) { $http = 'https://';
		} else { $http = 'http://'; }
		$search = str_replace( ' ','',$_REQUEST['range_address'] );
		$response = wp_remote_get( $http . 'maps.google.com/maps/api/geocode/json?address=' . $search . '&sensor=false' );
		$output = json_decode( $response['body'] );
		if ( ! is_wp_error( $response ) ) {
			if ( isset( $output->results[0]->geometry->location->lat ) ) {
				$lat = $output->results[0]->geometry->location->lat;
			}
			if ( isset( $output->results[0]->geometry->location->lng ) ) {
				$long = $output->results[0]->geometry->location->lng;
			}
		}
	} else {
		$ip  = ! empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
		$url = "http://ip-api.com/json/$ip";
		$data = wp_remote_get( $url, array(
			'timeout' => 120,
			'httpversion' => '1.1',
		) );
		if ( is_wp_error( $data ) ) {
			return $where;
		}
		if ( $data ) {
			$location = json_decode( $data['body'] );
			$lat = $location->lat;
			$long = $location->lon;
		}
	}
	if ( $lat != '' && $long != '' ) {
		$lat = $lat;
		$long = $long;
	} else {
		$city_map_setting = get_option( 'city_googlemap_setting' );
		$lat = ($current_cityinfo['lat'])? $current_cityinfo['lat']:$city_map_setting['map_city_latitude'];
		$long = ($current_cityinfo['lng'])?$current_cityinfo['lng'] :$city_map_setting['map_city_longitude'];
	}

	$miles_range = explode( '-',$_REQUEST['miles_range'] );
	$defaul_range = explode( '-',$_REQUEST['defaul_range'] );

	if ( ! empty( $miles_range ) ) {
		$to_miles = (trim( $miles_range[0] ))? trim( $miles_range[0] )  : '0';
		$miles = (trim( $miles_range[1] )) ? trim( $miles_range[1] ) : '1000';
	}
	/*  convert miles in to kilometer */
	if ( isset( $_REQUEST['radius_measure'] ) && strtolower( $_REQUEST['radius_measure'] ) == strtolower( 'kilometer' ) ) {
		$miles = $miles * 0.621;
		$to_miles = $to_miles * 0.621;
	}
	$tbl_postcodes = $wpdb->prefix . 'postcodes';
	if ( $lat != '' && $long != '' && (trim( $miles_range[0] ) != '1' || $defaul_range[1] != $miles_range[1]) ) {
		$where .= " AND ($wpdb->posts.ID in (SELECT post_id FROM  $tbl_postcodes WHERE truncate((degrees(acos( sin(radians(`latitude`)) * sin( radians('" . $lat . "')) + cos(radians(`latitude`)) * cos( radians('" . $lat . "')) * cos( radians(`longitude` - '" . $long . "') ) ) ) * 69.09),1) <= " . $miles . " AND truncate((degrees(acos( sin(radians(`latitude`)) * sin( radians('" . $lat . "')) + cos(radians(`latitude`)) * cos( radians('" . $lat . "')) * cos( radians(`longitude` - '" . $long . "') ) ) ) * 69.09),1) >= " . $to_miles . " ORDER BY truncate((degrees(acos( sin(radians(`latitude`)) * sin( radians('" . $lat . "')) + cos(radians(`latitude`)) * cos( radians('" . $lat . "')) * cos( radians(`longitude` - '" . $long . "') ) ) ) * 69.09),1) ASC))";
	}
	return $where;
}

